/* Encoder Library - Basic Example
   http://www.pjrc.com/teensy/td_libs_Encoder.html

   This example code is in the public domain.
*/

#include "motor.h"
#include "controller.h"
#include "encoder.h"
#include "comm.h"

#include <DueTimer.h>


/***************************************** 
  PROBLEMS WITH LIBRARY IMPORT ON ARDUINO.
  THEY ARE PLACED HERE FOR SIMPLICITY 
  ****************************************/

/** CONTROLLER.h **/
#ifdef __cplusplus
extern "C" {
#endif
void CONTROLLER_Start      ( long l_sampling_time );
#ifdef __cplusplus
} // extern "C"
#endif
/** END CONTROLLER.h **/

/** COMMUNICATION.h **/
#ifdef __cplusplus
extern "C" {
#endif
void COMMUNICATION_Start      ( long l_sampling_time );
#ifdef __cplusplus
} // extern "C"
#endif

#ifdef __cplusplus
extern "C" {
#endif
void COMMUNICATION_Stop      ( void );
#ifdef __cplusplus
} // extern "C"
#endif
/** END COMMUNICATION.h **/
/***************************************** 
  END PROBLEMS WITH LIBRARY IMPORT ON ARDUINO.
  THEY ARE PLACED HERE FOR SIMPLICITY 
  ****************************************/


/* FUNCTIONS definition */
void COMMUNICATION_ROB ( void );
void CONTROLLER_ROB ( void );

/* VARs definition */
#define CONTROLLER_SAMPLING_PERIOD    5   // in mSec
#define COMMUNICATION_SAMPLING_PERIOD 10  // in mSec


/* USER vars definition */
/* END USER vars definition */

void setup() 
{

  /* INIT USER vars */
  /* End INIT USER vars */

  /* INIT ENCODER */
  /* Pos */
  ENCODER_Init();
  /* Speed */
  ENCODER_StartSpeedCalculation(ENCODER_SPEED_CALCULATION_SAMPLING_PERIOD);

  /* INIT MOTOR  */
  MOTOR_Init();

  /* INIT COMMUNICATION  */
  COMMUNICATION_Init(115200);
  
  CONTROLLER_Start(CONTROLLER_SAMPLING_PERIOD);
  COMMUNICATION_Start(COMMUNICATION_SAMPLING_PERIOD);
}

/******************************
*******************************/

void CONTROLLER_ROB ( void )
{
  /* START CODE TO BE IMPLEMENTED BY THE STUDENTS */

  /* END CODE TO BE IMPLEMENTED BY THE STUDENTS */
}

/******************************
*******************************/

void COMMUNICATION_ROB ( void )
{
  /* START CODE TO BE IMPLEMENTED BY THE STUDENTS */

  /* END CODE TO BE IMPLEMENTED BY THE STUDENTS */
}

/******************************
*******************************/

void loop()
{
}


/******************************
*******************************/


/***************************************** 
  PROBLEMS WITH LIBRARY IMPORT ON ARDUINO.
  THEY ARE PLACED HERE FOR SIMPLICITY 
  ****************************************/

/** CONTROLLER.c **/
/* Input in mSec */
void CONTROLLER_Start ( long l_sampling_time )
{
  Timer3.attachInterrupt(CONTROLLER_ROB);
  Timer3.start(l_sampling_time * 1000); // Timer defined in uSec

}
/** END CONTROLLER.c **/

/** COMMUNICATION **/
void COMMUNICATION_Start ( long l_sampling_time )
{
  Timer2.attachInterrupt(COMMUNICATION_ROB);
  Timer2.start(l_sampling_time * 1000);
}

void COMMUNICATION_Stop ( )
{
  Timer2.stop();
}
/** END COMMUNICATION **/

/** ENCODER **/
/* Input in mSec */
void ENCODER_StartSpeedCalculation ( long l_sampling_time )
{
  Timer1.attachInterrupt(ENCODER_CalcSpeed);
  Timer1.start(l_sampling_time * 1000); // Timer defined in uSec
}
/** END ENCODER **/
/***************************************** 
  END PROBLEMS WITH LIBRARY IMPORT ON ARDUINO.
  THEY ARE PLACED HERE FOR SIMPLICITY 
  ****************************************/

